import React from 'react';
import ReactDom from 'react-dom';
import { arc } from 'd3';

const width = 900;
const height = 500;
const centerX = width / 2;
const centerY = height / 2;
const strokeWidth = 10;
const eyeOffsetX = 70;
const eyeOffsetY = 100;
const eyeRx = 25;
const eyeRy = 35;
const noseR = 50;
const noseWidth = 5;
const mouthWidth = 100;
const mouthRadius = 140;

const mouthArc = arc()
  .innerRadius(mouthRadius)
  .outerRadius(mouthRadius + mouthWidth)
  .startAngle((Math.PI * 5) / 8)
  .endAngle((Math.PI * 11) / 8);

/* this is for mouth while we can change the above one for beard
const beardArc = arc()
  .innerRadius(mouthRadius)
  .outerRadius(mouthRadius + mouthWidth)
  .startAngle((Math.PI * 5) / 8)
  .endAngle((Math.PI * 11) / 8);
*/
const nose = arc()
  .innerRadius(noseR)
  .outerRadius(noseR + noseWidth)
  .startAngle(0)
  .endAngle(Math.PI * 2);

const leftCheek = arc()
  .innerRadius(noseR)
  .outerRadius(noseR + noseWidth)
  .startAngle(0)
  .endAngle(Math.PI / 2);

const eyeArc = d3.arc()
    .innerRadius(26)
    .outerRadius(40)
    .startAngle(-Math.PI/3)
    .endAngle(Math.PI/3);

const earArc = d3.arc()
    .innerRadius(0)
    .outerRadius(75)
    .startAngle(-Math.PI/2)
    .endAngle(Math.PI/2);

const App = () => (
  <svg width={width} height={height}>
    <g transform={`translate(${centerX}, ${centerY})`}>
      <circle
        r={centerY - strokeWidth / 2}
        fill="#f7b47d"
        stroke="black"
        stroke-width={strokeWidth}
      />
      <ellipse
        cx={-eyeOffsetX}
        cy={-eyeOffsetY}
        rx={eyeRx}
        ry={eyeRy}
      />
      <ellipse
        cx={+eyeOffsetX}
        cy={-eyeOffsetY}
        rx={eyeRx}
        ry={eyeRy}
      />
      <circle
        r={noseR}
        fill="#e3351d"
        stroke="black"
        stroke-width={noseWidth}
      />
      
      <path 
        d = {eyeArc()}
        transform = "rotate(-9)    translate(-50,-125)"
        fill = "black"
      />
      
      <path 
        d = {earArc()} 
        transform = "rotate(50) translate(0,-240)"/>
      <path 
        d = {earArc()} 
        transform = "rotate(-50) translate(0,-240)"/>
      
        
        <path 
        d = {eyeArc()}
        transform = "rotate(-2)    translate(70,-115)"
        fill = "black"
      />
      <path d={mouthArc()} />
      <path d={nose()} />
      <circle
        cx={centerX - noseR}
        cy={centerY}
        fill="#e3351d"
        stroke="black"
        stroke-width={noseWidth}
      />
    </g>
  </svg>
);

const rootElement = document.getElementById('root');
ReactDom.render(<App />, rootElement);
